#!/usr/bin/perl

# --------------------------------------------------------------------
# A perl version of the python example smile.py.  This demonstrates
# some of the perl bindings for the Ygl library.  Please note that
# there are a few extra perl functions to handle creation, deletion
# and deferencing of some of the pointers used by Ygl - read the
# perl5.doc in this directory. Try to read the python examples - they
# are pretty easy to read.  Also note that due to the inability of
# SWIG to handle arbitrary arguements to a C function the defpup()
# function does not have a python equivalent. However the addtopup
# function works (hacked a bit) and I have added a function called
# add2pup() which is slightly different.  For a simple but
# illustrative example look at the menutest.py python example that is
# located in ../python/ .  Please also look through this example
# carefully.  I know very little perl and if someone can convert my
# menutest.py in the python directory to a perl equivalent and give it
# to me I'd be very happy to include it in this distribution. :)
# ------- Prabhu Ramachandran  <prabhu@aero.iitm.ernet.in> -----------

use ygl;


#initialisation
ygl::prefsize(100,100);
$w = ygl::winopen("SMILE!");

#background
ygl::color($ygl::BLACK);
ygl::clear();

#the face
ygl::color($ygl::RED);
ygl::circfi(50, 50, 40);

#eyes
ygl::color($ygl::WHITE);
ygl::circfi(30, 60, 10);
ygl::circfi(70, 60, 10);
ygl::color($ygl::BLACK);
ygl::circfi(30, 60,  5);
ygl::circfi(70, 60,  5);

#smile
ygl::arci(50, 50, 25, 2000, 3400);

#the gflush() is very important. Try the script without it! :(
#Also note that sleep(0) doesnt flush the pipeline

ygl::gflush();

#need ppmtogif (an executable) for this to work.
#gl2ppm("| ppmtogif > normal.gif")

# the wink

ygl::sleep(2);
ygl::color($ygl::RED);
ygl::circfi(30, 65, 10);
ygl::gflush();

#gl2ppm("| ppmtogif > wink.gif")

ygl::sleep(1);

ygl::color($ygl::WHITE); 
ygl::circfi(30, 60, 10);
ygl::color($ygl::BLACK); 
ygl::circfi(30, 60,  5);
ygl::gflush();

ygl::sleep(2);
ygl::gexit();
