#!/usr/bin/tclsh

# --------------------------------------------------------------------
# A tcl version of the python example smile.py.  This demonstrates
# some of the tcl bindings for the Ygl library.  Please note that
# there are a few extra tcl functions to handle creation, deletion and
# deferencing of some of the pointers used by Ygl - read the tcl8.doc
# in this directory also look at the python examples (they are pretty
# easy to read).  Also note that due to the inability of SWIG to
# handle arbitrary arguements to a C function the defpup() function
# does not have a python equivalent. However the addtopup function
# works (hacked a bit) and I have added a function called add2pup()
# which is slightly different.  For a simple but illustrative example
# look at the menutest.py python example that is located in ../python/
# Please also look through this example carefully.  I know very little
# tcl and if someone can convert my menutest.py in the python
# directory to a tcl equivalent and give it to me I'd be very happy to
# include it in this distribution. :)
# ------- Prabhu Ramachandran  <prabhu@aero.iitm.ernet.in> -----------


load ./ygl.so ygl

#initialisation
prefsize 100 100 
set w [ winopen "SMILE!" ]

#background
color $BLACK 
clear  

#the face
color $RED 
circfi 50  50  40 

#eyes
color $WHITE 
circfi 30  60  10 
circfi 70  60  10 
color $BLACK 
circfi 30  60   5 
circfi 70  60   5 

#smile
arci 50  50  25  2000  3400 

#the gflush   is very important. Try the script without it! :(
#Also note that sleep 0  doesnt flush the pipeline

gflush  

#need ppmtogif  an executable  for this to work.
#gl2ppm "| ppmtogif > normal.gif" 

# the wink

sleep 2 
color $RED 
circfi 30  65  10 
gflush  

#gl2ppm "| ppmtogif > wink.gif" 

sleep 1 

color $WHITE  
circfi 30  60  10 
color $BLACK  
circfi 30  60   5 
gflush  

sleep 2 
gexit  
