// SWIG Interface file for Python-Ygl. 
// Prabhu Ramachandran <prabhu@aero.iitm.ernet.in>

%module ygl
%{
#include "Ygl.h"
#include <unistd.h>
#include "mouse_zoom.h"
%}

// -----------------------------------------------------------------
// Sticking the typedefs here helps SWIG out.  These typedefs were
// obtained from the Ygl.h and Ygltypes.h files.
typedef signed   char    Int8;
typedef unsigned char   Uint8;
typedef signed   short   Int16;
typedef unsigned short  Uint16;
typedef signed   int     Int32;
typedef unsigned int    Uint32;
typedef          float  Float32;
typedef          double Float64;
typedef char			Char8;
typedef char			Void;
  
typedef Uint8			Byte;
typedef Uint8			RGBvalue;
  
typedef Uint16		Colorindex;
typedef Uint16		Device;
typedef Uint16		Linestyle;
  
typedef Int16			Angle;
typedef Int16			Scoord;
typedef Int16			Screencoord;
  
typedef Int32			Icoord;
  
typedef Float32		Coord;
  
typedef Float32		Matrix[4][4];

extern unsigned int sleep(unsigned int );
// -----------------------------------------------------------------

// -----------------------------------------------------------------
// Create nice pointer/array representations for various types.
%include "cpointer.i"
%include "carrays.i"

%pointer_class(Int16, Int16_p);
%pointer_class(Int32, Int32_p);
%pointer_class(Coord, Coord_p);
%pointer_class(Screencoord, Screencoord_p);
%pointer_class(Uint8, Uint8_p);

%include "Ygl.h"

// Mouse based zoom feature.
%include mouse_zoom.h

%inline %{
// Below I salvage menus by providing a hack to get menu's to work
Int32 dummy(Int32 Int32_menu) 
{
	return Int32_menu;
}	

void add2pup(Int32 Int32_menu, Char8 *str)
{
	addtopup(Int32_menu, str, (Int32)dummy);
}
%}

